﻿using System;
using Wisej.Web;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using System.IO;
using System.Text;


namespace WisejSyncfusionTest.sfControls
{
    public partial class sfSpreadsheet : Wisej.Web.UserControl
    {
        public sfSpreadsheet()
        {
            InitializeComponent();
        }

		private void ejSpreadsheet1_WebRequest(object sender, WebRequestEventArgs e)
		{
			// load the file?
			if (e.Request.Files.Count == 1)
			{
				e.Response.Write(LoadFile(e.Request.Files[0].InputStream));
			}
			else
			{
				SaveFile(
					e.Request.Form["fileName"],
					e.Request["format"],
					e.Request["sheetModel"],
					e.Request["sheetData"]);
			}
		}

		private void SaveFile(string fileName, string fileFormat, string sheetModel, string sheetData)
		{
			switch (fileFormat)
			{
				case "xls":
					Spreadsheet.Save(sheetModel, sheetData, fileName, ExportFormat.XLS);
					break;
				case "xlsx":
					Spreadsheet.Save(sheetModel, sheetData, fileName, ExportFormat.XLSX);
					break;
				case "pdf":
					Spreadsheet.Save(sheetModel, sheetData, fileName, ExportFormat.PDF);
					break;
				case "csv":
					Spreadsheet.Save(sheetModel, sheetData, fileName, ExportFormat.CSV);
					break;
			}
		}

		private string LoadFile(Stream stream)
		{
			var importRequest = new ImportRequest()
			{
				FileStream = stream,
			};
			return Spreadsheet.Open(importRequest);
		}
	}
}
